%
%   KOrecord_spklatency.m
%       Measures first-spike latency for KOrecord.m
%

%% Select a window for getting first spikes
% polarity=pulsepol(1);
% if (polarity=='N')
% %     wins = prestimdur + 0.1
%       wins = prestimdur
% elseif (polarity=='R')
% %     wins= prestimdur+pulsedur + 0.1
%       wins= prestimdur+pulsedur
% end
% wine = wins + 3
disp(' ')
wins = input('Enter start of window (ms): ');
wine = input('Enter end of window (ms): ');
disp(' ')
%% Make sure spikes are not being double counted
[a b]=size(response);
for i=1:a
    numspksinwin(i) = length(find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    spktimesinwin = spktimes_byrep(i,find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    spkampsinwin = spkamps_byrep(i,find((spktimes_byrep(i,:)>=wins)&(spktimes_byrep(i,:)<wine)));
    if (numspksinwin(i) > 1)
        disp(' ')
        delspks=input('More than one spike in window on a single sweep! Delete extra spikes? (y/n)','s');
        disp(' ')
        if (delspks=='y')
            % FOR MEASURING POSITIVE PHASE OF SPIKES
            [maxamp maxwhere]=max(spkampsinwin);
            spktimesinwin_byrep(i)=spktimesinwin(maxwhere);
            spkampsinwin_byrep(i)=spkampsinwin(maxwhere);
            numspksinwin_byrep(i)=1;
%               FOR MEASURING NEGATIVE PHASE OF SPIKES
%              [minamp minwhere]=min(spkampsinwin);
%             spktimesinwin_byrep(i)=spktimesinwin(minwhere);
%             spkampsinwin_byrep(i)=spkampsinwin(minwhere);
%             numspksinwin_byrep(i)=1;
        elseif (delspks=='n')
            spktimeswin_byrep(i)=spktimesinwin(1);
            spkampsinwin_byrep(i)=spkampsinwin(1);
            numspksinwin_byrep(i)=numspksinwin(i);
        end
    elseif (numspksinwin(i)==1)
        spktimesinwin_byrep(i)=spktimesinwin;
        spkampsinwin_byrep(i)=spkampsinwin;
        numspksinwin_byrep(i)=1;
    elseif (numspksinwin(i)==0)
        spktimesinwin_byrep(i)=NaN;
        spkampsinwin_byrep(i)=NaN;
        numspksinwin_byrep(i)=0;
    end
    clear spktimesinwin spkampsinwin
end
%% Find time of first spike in each stimulus repetition
[a b]=size(numspksinwin_byrep);
firstspktime=[];
% for i=1:a
%     if (~isempty(find(((spktimes_byrep(i,:)>=wins) & (spktimes_byrep(i,:)<wine)), 1)))
%     firstspktime(i)=spktimes_byrep(i,find((spktimes_byrep(i,:)>=wins) & (spktimes_byrep(i,:)<wine),1));
%     else
%         firstspktime(i)=NaN;
%     end
% end
% firstspktime
% avg_firstspktime=nanmean(firstspktime);
firstspktime=spktimesinwin_byrep
avg_firstspktime=nanmean(firstspktime);

%% Display average first-spike time
disp(' ')
disp(['  Average Time of First Spike = ' sprintf('%g',avg_firstspktime) ' ms'])
disp(' ')